=== debian/changelog ===
ros-indigo-grasp-planning-graspit (1.2.0-0trusty) trusty; urgency=high

  * Update
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Fri, 05 Jan 2018 23:00:00 -0000

ros-indigo-grasp-planning-graspit (1.1.3-0trusty) trusty; urgency=high

  * Tested with current version of graspit
  * Adaptation for graspit upstream merge
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Thu, 04 Jan 2018 23:00:00 -0000

ros-indigo-grasp-planning-graspit (1.1.1-0trusty) trusty; urgency=high

  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Sat, 06 Aug 2016 22:00:00 -0000

ros-indigo-grasp-planning-graspit (1.1.0-0trusty) trusty; urgency=high

  * New version to work with new update on graspit fork
  * Removed camera parameters setting as this is done in GraspitCore now
  * EGPlanner working with new graspit headless branch
  * Updated command line parsing in grasp_planning.cpp and adjusted some parameters for prismatic joints in urdf2graspit
  * removed more unneeded includes
  * removed unneeded includes
  * removed unneeded includes of ivmgrHeadless.h
  * Added option to change object position and max number of iterations as command line argument in grasp_planning.cpp
  * Now can save planning results without objects -only pose- as well
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Mon, 25 Jul 2016 22:00:00 -0000

ros-indigo-grasp-planning-graspit (1.0.0-0trusty) trusty; urgency=high

  * Removed direct Qt dependencies from urdf2graspit, as this is now in urdf2inventor
  * Now compiles with new graspit and new urdf2inventor
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Tue, 07 Jun 2016 22:00:00 -0000

ros-indigo-grasp-planning-graspit (0.1.5-0trusty) trusty; urgency=high

  * Added pre-grasp state computation
  * Added helper class EigenGraspPlannerClient and some example grasp results for Jaco
  * Now supports an extra auto-grasp as finalization of planning, and control of how many results are saved
  * Fixed broken hand transform which was returned for resulting grasps
  * Added means to save a Grasp.msg and added a table obstacle
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Fri, 01 Apr 2016 22:00:00 -0000

ros-indigo-grasp-planning-graspit (0.1.3-0trusty) trusty; urgency=high

  * changed catkin_package system depends to names in rosdep
  * Adapted cmake file to for jenkins, and removed c++11 flag, which required fixing two little things in sources
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Mon, 07 Mar 2016 23:00:00 -0000

ros-indigo-grasp-planning-graspit (0.1.2-0trusty) trusty; urgency=high



 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Thu, 03 Mar 2016 23:00:00 -0000

ros-indigo-grasp-planning-graspit (0.1.0-0trusty) trusty; urgency=high

  * now also adds graspit_simulator_standalone
  * graspit fork is now compiled into libraries here and doesn't need to be installed separately
  * Contributors: Jennifer Buehler

 -- Jennifer Buehler <jennifer.e.buehler@gmail.com>  Tue, 01 Mar 2016 23:00:00 -0000
