=== debian/control ===
Source: ros-indigo-grasp-planning-graspit
Section: misc
Priority: extra
Maintainer: Jennifer Buehler <jennifer.e.buehler@gmail.com>
Build-Depends: debhelper (>= 9.0.0), git-core, libblas-dev, libboost-all-dev, libcoin80-dev, liblapack-dev, libqhull-dev, libqt4-dev, libsoqt4-dev, ros-indigo-catkin, ros-indigo-eigen-conversions, ros-indigo-roslint
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-grasp-planning-graspit
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libblas-dev, libboost-all-dev, libcoin80-dev, liblapack-dev, libqhull-dev, libqt4-dev, libsoqt4-dev, ros-indigo-eigen-conversions
Description: The grasp_planning_graspit package This package.xml file is only required if the source is to be built with catkin.
 You can also build using cmake only, in which case this file is not required.
